<?php
// Own namespace
namespace Org\Mxchange\CoreFramework\Iterator\Registry;

// Import framework stuff
use Org\Mxchange\CoreFramework\Generic\FrameworkInterface;

// Import SPL stuff
use \Iterator;

/**
 * A registry iterator interface
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2020 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
interface IteratableRegistry extends FrameworkInterface, Iterator {

	/**
	 * Initializes this iterator by scanning over the registry for all keys.
	 *
	 * @return	void
	 * @throws	LogicException	If a registry entry does not implement Registerable
	 * @throws	NullPointerException	If criteriaKey or criteriaMethod is not set but a call-back instance is set
	 */
	function initIterator (FrameworkInterface $callbackInstance = NULL, $criteriaKey = NULL, $criteriaMethod = NULL);

}
